(* wrappi
 * Copyright (C) 2011 Red Hat Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *)

(** Accumulator.

    This module "accumulates" the typedefs, entry points etc as they
    are declared (see pa_wrap.ml).

    It then performs some manipulations on the API, mainly resolving
    typedefs within types, and constructs a {!Wrappi_types.api}
    object which describes the whole API. *)

val add_typedef : Wrappi_types.typedef -> unit
val add_enum : Wrappi_types.enum -> unit
val add_struct : Wrappi_types.struct_decl -> unit
val add_union : Wrappi_types.union -> unit
val add_entry_point : Wrappi_types.entry_point -> unit

val get_api : unit -> Wrappi_types.api
